/*
 * ConnectCode
 *
 * Copyright (c) 2006-2019 ConnectCode Pte Ltd (https://www.barcoderesource.com)
 * All Rights Reserved.
 *
 * This source code is protected by International Copyright Laws. You are only allowed to modify
 * and include the source in your application if you have purchased a Distribution License.
 *
 * http://www.barcoderesource.com
 *
 */

import { LitElement, html } from 'lit-element';
import { encode, getText } from './js/connectcode-javascript-code93'

class Code93 extends LitElement {
  constructor() {
    super();
    this.input = '12345678';
  }
/*
*/

  render() {
    return html`
    <style>
    @font-face {
      font-family: CCode93_S3_Trial;
      src: url("./fonts/ConnectCode93_S3_Trial.woff2") format("woff2");
    }      
    .Code93 {width: 5in}
    .barcode_code93 {font-weight: normal; font-style: normal; line-height:normal; font-family: 'CCode93_S3_Trial', sans-serif; font-size: 32px}
    .barcode_text_code93 {font-weight: normal; font-style: normal; line-height:normal; font-family: sans-serif; font-size: 28px}

    </style>
    <div class='Code93'>
      <center>	
        <div class='barcode_code93'>${encode(this.input,this.checkDigit)}</div>	
        <div class='barcode_text_code93'>${getText()}</div>	
      </center>
      </div>
`;
  }

  static get properties() {
    return {
      input: String,
      checkDigit: String
    }
  }
}

customElements.define('barcode-code93', Code93);
