/*
 * ConnectCode
 *
 * Copyright (c) 2006-2019 ConnectCode Pte Ltd (https://www.barcoderesource.com)
 * All Rights Reserved.
 *
 * This source code is protected by International Copyright Laws. You are only allowed to modify
 * and include the source in your application if you have purchased a Distribution License.
 *
 * http://www.barcoderesource.com
 *
 */

import { LitElement, html } from 'lit-element';
import { encode, getText } from './js/connectcode-javascript-upce'

// This element is *not* connected to the Redux store.
class UPCE extends LitElement {
  constructor() {
    super();
    this.input = '12345678';
  }

  render() {
    return html`
    <style>
    @font-face {
      font-family: CCodeUPCEAN_HRBS3_Trial;
      src: url("./fonts/ConnectCodeUPCEAN_HRBS3_Trial.woff2") format("woff2");
    }      
    .UPCE {width: 5in}
    .barcode_upce {font-weight: normal; font-style: normal; line-height:normal; font-family: 'CCodeUPCEAN_HRBS3_Trial', sans-serif; font-size: 32px}
    .barcode_text_upce {font-weight: normal; font-style: normal; line-height:normal; font-family: sans-serif; font-size: 28px}

    </style>
    <div class='UPCE'>
      <center>	
        <div class='barcode_upce'>${encode(this.input,this.extendedStyle)}</div>	
        <div class='barcode_text_upce' style='display:none'>${getText()}</div>	
        <!-- Change display:none to display:block for Standard Style UPCE -->
      </center>
      </div>
`;
  }

  static get properties() {
    return {
      input: String,
      extendedStyle: String
    }
  }
}

customElements.define('barcode-upce', UPCE);
