-- Copyright 2006-2020 ConnectCode Pte Ltd. All Rights Reserved.
-- This source code is protected by Copyright Laws. You are only allowed to modify
-- and include the source in your application if you have purchased a Distribution License.
-- ===================================================================================
-- ConnectCode Barcode TSQL UDF for SQL Server
--
-- The formulas in this file can be used for creating barcodes in Microsoft SQL SErver.

CREATE OR ALTER FUNCTION dbo.Code128AutoUNICHR(@DataNum  int )
  RETURNS nvarchar(20)
  AS
  BEGIN
      DECLARE @ReturnString nvarchar(20);
	  SET @ReturnString='';
	  IF @DataNum>=191 and @DataNum<=199  
		   SET @ReturnString = nchar(@DataNum);
	  ELSE IF @DataNum>=227 and @DataNum<=238
		   SET @ReturnString = nchar(@DataNum);
      ELSE
		   SET @ReturnString = CHAR(@DataNum);

      RETURN(@ReturnString);
  END
GO

CREATE OR ALTER FUNCTION dbo.Code128AutodetectAllNumbers (@Data nvarchar(255))
  RETURNS int
  AS
  BEGIN    
	DECLARE @Tempchar nvarchar(1);
	DECLARE @Onevalue int;
	DECLARE @Allnumbers int;
	DECLARE @Datalength int;
	DECLARE @Counter int;
	SET @Onevalue=0;
	SET @Allnumbers=1;
	SET @Datalength=LEN(@Data);

	IF @Datalength %2 = 1
		SET @Allnumbers=0;
    ELSE
	BEGIN
		SET @Counter=1;
		
		WHILE @Counter <= @Datalength
	    BEGIN		
		    SET @Tempchar = SUBSTRING(@Data,@Counter,1);
	        SET @Onevalue = ASCII(@Tempchar);
			IF @Onevalue >= 48 AND @Onevalue <=57  
				SET @Onevalue=@Onevalue;
			ELSE
				SET @Allnumbers=0;      
            SET @Counter=@Counter+1;
		END
		
	END
	RETURN @Allnumbers;
  END

GO

CREATE OR ALTER FUNCTION dbo.Code128AutoScanAhead_8orMore_Numbers (@Data  nvarchar(255), @X int)
  RETURNS int
  AS
  BEGIN    
   DECLARE @Onevalue int;
   SET @Onevalue=0;
   DECLARE @NumNumbers int;	
   SET @NumNumbers=0;
   DECLARE @Exitvalue int;	
   SET @Exitvalue=0;   
   DECLARE @Tempchar nvarchar(1); 
   DECLARE @Datalength int;
   SET @Datalength=LEN(@Data);
   DECLARE @Y int
   SET @Y=@X;
   
    WHILE @Y <= @Datalength AND @Exitvalue=0
	BEGIN
    	SET @Tempchar = SUBSTRING(@Data,@Y,1);
    	SET @Onevalue = ASCII(@Tempchar);
    	IF @Onevalue >= 48 AND @Onevalue <= 57 
    		SET @NumNumbers = @NumNumbers+1;
    	ELSE
    		SET @Exitvalue=1;
   		SET @Y = @Y+1;
    END

    IF @NumNumbers>8
	BEGIN
    	IF @NumNumbers % 2 =1
    		SET @NumNumbers=@NumNumbers-1;
	END
    RETURN @NumNumbers;  
 END
GO

CREATE OR ALTER FUNCTION dbo.getCode128AutoAutoSwitchingAB(@Data nvarchar(255))
  RETURNS nvarchar(255)
  AS
  BEGIN    
   DECLARE @Tempchar nvarchar(1);
   DECLARE @Onevalue int;
   DECLARE @X int;
   DECLARE @Num int;
   DECLARE @Shiftvalue int;
   DECLARE @Datalength int;
   DECLARE @StrResult nvarchar(560)='';
   SET @Onevalue=0;
   SET @X=1;
   SET @Num=0;
   SET @Shiftvalue=230;
   SET @Datalength=LEN(@Data);
   
   WHILE @X <= @Datalength
   BEGIN
 	SET @Tempchar = SUBSTRING(@Data,@X,1);
 	SET @Onevalue=ASCII(@Tempchar);
 
 	IF @Onevalue = 31 
	BEGIN
 		SET @Onevalue = @Onevalue + 96 + 100; 
 		SET @StrResult = @StrResult + dbo.Code128AutoUNICHR(@Onevalue);
	END
 	ELSE IF @Onevalue = 127
	BEGIN
 		SET @Onevalue = @Onevalue+ 100; 
 		SET @StrResult = @StrResult + dbo.Code128AutoUNICHR(@Onevalue);
	END
	
 	ELSE
	BEGIN
 		SET @Num=dbo.Code128AutoScanAhead_8orMore_Numbers(@Data,@X);		
		/*
		SET @StrResult =CAST(@Num AS nvarchar);
		*/		
 		IF @Num>=8
		BEGIN

		   /*
 			SET @StrResult=OptimizeNumbers(@Data,x,strResult,num);
  		   */

		    DECLARE @ON_Twonum   nvarchar(2);
		    DECLARE @ON_Onevalue int;
			SET @ON_Onevalue=0;
			DECLARE @ON_BtoC     int = 231;
			SET @ON_BtoC=231;
			DECLARE @ON_CtoB     int = 232;
			SET @ON_CtoB=232;
			DECLARE @ON_endpoint int = @X+@Num;
			DECLARE @ON_newResult nvarchar(560);  
			SET @ON_newResult='';		
			SET @ON_newResult = @StrResult + dbo.Code128AutoUNICHR(@ON_BtoC);
			
			WHILE @X < @ON_endpoint
		    BEGIN
	    		SET @ON_Twonum = SUBSTRING(@Data,@X,2);
				SET @Onevalue = CAST(@ON_Twonum AS INT);
				IF @Onevalue <= 94 AND @Onevalue >= 0
				  SET @ON_newResult = @ON_newResult + dbo.Code128AutoUNICHR(@Onevalue+32);
				ELSE IF @Onevalue <= 106 AND @Onevalue >= 95
				  SET @ON_newResult = @ON_newResult + dbo.Code128AutoUNICHR(@Onevalue+100+32);
				ELSE
				  SET @ON_newResult = @ON_newResult; --do nothing	
				SET @X = @X+2;
			END
			SET @ON_newResult = @ON_newResult + dbo.Code128AutoUNICHR(@ON_CtoB);
 			SET @X=@X-1;
       		SET @StrResult = @ON_newResult;
		
		END				
 		ELSE
		BEGIN
       		SET @StrResult = @StrResult + dbo.Code128AutoUNICHR(@Onevalue);
	    END
	   		
    END 
   SET @X=@X+1;
   END
   
   RETURN @StrResult;
END
GO

 CREATE OR ALTER FUNCTION dbo.Code128AutoaddShift (@Data nvarchar(255))
  RETURNS nvarchar(255)
  AS
  BEGIN    
    DECLARE @Filtereddata nvarchar(560);
	SET @Filtereddata='';
    DECLARE @tempchar     nvarchar(1);
	SET @Filtereddata='';
    DECLARE @Shiftvalue   int;
	SET @shiftvalue = 230;
    DECLARE @Onevalue   int = 0;
	SET @Filtereddata = 0;
    DECLARE @Datalength int;	
	SET @Datalength=LEN(@Data);
    DECLARE @Counter   int = 1;
	
	WHILE @Counter <= @Datalength
	BEGIN
	 SET @tempchar = SUBSTRING(@Data,@Counter,1);
     SET @Onevalue = ASCII(@tempchar);
     IF @Onevalue >= 0 AND @Onevalue <=31 
	 BEGIN
	   SET @Filtereddata = @Filtereddata + dbo.Code128AutoUNICHR(@shiftvalue);
	   SET @Onevalue = @Onevalue + 96;
	   SET @Filtereddata = @Filtereddata + dbo.Code128AutoUNICHR(@Onevalue);
     END
     ELSE
	   SET @Filtereddata = @Filtereddata + @tempchar;
   
	 SET @Counter = @Counter+1;
	END
   
   RETURN @Filtereddata;
   END 

GO

 CREATE OR ALTER FUNCTION dbo.generateCode128AutoCheckDigitAB(@Data nvarchar(255))
   RETURNS nvarchar(255)
  AS
  BEGIN    
    DECLARE @Tempchar nvarchar(1);
	SET @Tempchar='';
    DECLARE @Datalength int =LEN(@Data);
    DECLARE @Sumvalue        int =104;
    DECLARE @Result     int = -1;
    DECLARE @StrResult  nvarchar(2) = '';
    DECLARE @X          int =1;
    DECLARE @Endpoint   int =0;
    DECLARE @Num        int =0;
    DECLARE @Weight     int =1;
    DECLARE @BtoC       int =99;
    DECLARE @CtoB       int =100;

  WHILE  @X <= @Datalength
  BEGIN
	SET @Num=dbo.Code128AutoScanAhead_8orMore_Numbers(@Data,@X);
	IF @Num>=8
	BEGIN
	  SET @Endpoint=@X+@Num;	
	  SET @Sumvalue = @Sumvalue + (@BtoC * @Weight);
	  SET @Weight=@Weight+1;
	  WHILE  @X < @Endpoint
	  BEGIN
		  SET @Num = CAST(SUBSTRING(@Data,@X,2) AS INT);
		  SET @Sumvalue = @Sumvalue + (@Num * @Weight);
		  SET @X=@X+2;
		  SET @Weight=@Weight+1;
	  END 
	  SET @Sumvalue = @Sumvalue + (@CtoB * @Weight);
	  SET @Weight=@Weight+1;
	END
	ELSE
	BEGIN
 	    SET @Tempchar=SUBSTRING(@Data,@X,1);
		SET @Num = ASCII(@Tempchar);
		IF @Num <= 31 AND @Num >= 0
			SET @Num = @Num + 64;
		ELSE IF @Num <= 127 AND @Num >= 32 
			SET @Num = @Num - 32;
		ELSE IF @Num = 230 
			SET @Num = 98;  
		ELSE 
			SET @Num = -1;
		
		SET @Sumvalue = @Sumvalue + (@Num * @Weight);
		SET @X = @X+1;
		SET @Weight = @Weight+1;
	END
  END
  SET @Result=@Sumvalue % 103;
  IF @Result <= 94 AND @Result >= 0
  	SET @Result = @Result+32;
  ELSE IF @Result <= 106 AND @Result >= 95
  	SET @Result = @Result + 100 + 32;
  ELSE 
  	SET @Result = -1;
  IF @Result=-1 
    SET @StrResult='';	  
  ELSE
    SET @StrResult=dbo.Code128AutoUNICHR(@Result);	

  return @StrResult;

END

GO

CREATE OR ALTER FUNCTION dbo.EncodeCode128Auto( @InputData nvarchar(255))
  RETURNS nvarchar(255)
  AS
  BEGIN    
	  DECLARE @TempChar nvarchar(2);
	  DECLARE @Weight int;
      DECLARE @Sumvalue int;
      DECLARE @Onevalue int;
      DECLARE @Chkvalue int;
	  DECLARE @CD nvarchar(2);
      DECLARE @FilteredData nvarchar(255);
      DECLARE @ReturnData nvarchar(560); 
	  DECLARE @FilteredLength int;
	  DECLARE @Counter int;

      SET @Weight = 1;
      SET @Sumvalue = 0;
      SET @Onevalue = 0;
      SET @Chkvalue = 0;
	  SET @FilteredData='';
	  SET @ReturnData='';
	  SET @FilteredLength = LEN(@InputData);
      SET @Counter = 1;

	  IF @FilteredLength <= 0 
	  BEGIN
	      SET @ReturnData = ''; 
		  RETURN(@ReturnData);
	  END

	  WHILE  @Counter <= @FilteredLength
      BEGIN
		SET @TempChar = SUBSTRING(@InputData,@Counter,1);
		SET @Onevalue = ASCII(@TempChar);
		IF @Onevalue >= 0 AND @Onevalue <=127  
			SET @FilteredData = @FilteredData + @Tempchar;
		SET @Counter=@Counter+1;
	  END

	  SET @FilteredLength = LEN(@FilteredData);	
	  IF @FilteredLength > 254
        SET @FilteredData = SUBSTRING(@FilteredData,1,254);

      SET @FilteredLength = LEN(@FilteredData);	
      IF @FilteredLength IS NULL 
	    RETURN '';
	  IF dbo.Code128AutodetectAllNumbers(@FilteredData) = 0
	   BEGIN
		  SET @CD=dbo.generateCode128AutoCheckDigitAB(@FilteredData); 
		  SET @FilteredData=dbo.getCode128AutoAutoSwitchingAB(@FilteredData);
		  SET @ReturnData = dbo.Code128AutoUNICHR(236) + @FilteredData + @CD + dbo.Code128AutoUNICHR(238);
		  /*
		  SET @ReturnData = 'SIMI:';
		  */
	   END
	  ELSE
      BEGIN
			 SET @FilteredLength = LEN(@FilteredData);	
			 SET @Sumvalue = 105;

			 IF @FilteredLength IS NULL
				RETURN '';

			 SET @Counter=1;
			 WHILE  @Counter <= @FilteredLength
			 BEGIN
			  IF @Counter % 2 = 1
			  BEGIN
				SET @TempChar = SUBSTRING(@FilteredData,@Counter,2);
				SET @Onevalue = CAST(@TempChar AS INT);
				SET @Chkvalue = @Onevalue;
				SET @Sumvalue = @Sumvalue + (@Chkvalue * @Weight);
				SET @Weight = @Weight + 1;
				IF @Onevalue <= 94 AND @Onevalue >= 0 
				  SET @ReturnData = @ReturnData + dbo.Code128AutoUNICHR(@Onevalue+32);
				ELSE IF @Onevalue <= 106 AND @Onevalue >= 95 
				  SET @ReturnData = @ReturnData + dbo.Code128AutoUNICHR(@Onevalue+100+32);
				ELSE
				  SET @ReturnData = @ReturnData;
			  END
			  SET @Counter=@Counter+1;	  
			 END
			 SET @FilteredData=@ReturnData;
			 SET @Sumvalue = @Sumvalue % 103;
			 IF @Sumvalue <= 94 AND @Sumvalue >= 0 
			  SET @CD = dbo.Code128AutoUNICHR(@Sumvalue+32);
			 ELSE IF @Sumvalue <= 106 AND @Sumvalue >= 95 
			  SET @CD = dbo.Code128AutoUNICHR(@Sumvalue+100+32);
			 ELSE
			  SET @CD = ''; -- inputvalue = -1 

			 SET @ReturnData = dbo.Code128AutoUNICHR(237) + @FilteredData + @CD + dbo.Code128AutoUNICHR(238);
      End
   RETURN @ReturnData;

  END
GO