-- Copyright 2006-2020 ConnectCode Pte Ltd. All Rights Reserved.
-- This source code is protected by Copyright Laws. You are only allowed to modify
-- and include the source in your application if you have purchased a Distribution License.
-- ===================================================================================
-- ConnectCode Barcode TSQL UDF for SQL Server
--
-- The formulas in this file can be used for creating barcodes in Microsoft SQL SErver.

CREATE OR ALTER FUNCTION dbo.EncodeCode39( @InputData nvarchar(255), @CheckDigit int )
  RETURNS nvarchar(255)
  AS
  BEGIN
      DECLARE @FilteredData nvarchar(255);
      DECLARE @Result nvarchar(255);
	  DECLARE @FilteredLength int;
	  DECLARE @OneValue int;
	  DECLARE @SumValue int;
	  DECLARE @CD nchar='';
	  SET @OneValue = 0;
      SET @SumValue = 0;

	  SET @FilteredLength = LEN(@InputData);
	  SET @Result='';
	  SET @FilteredData='';
	  DECLARE @Counter int;
      SET @Counter = 1;

	  IF @FilteredLength <= 0 
	  BEGIN
	      SET @Result = '*' + '*'; 
		  RETURN(@Result);
	  END

	  WHILE @Counter <= @FilteredLength
	  BEGIN
		  DECLARE @TempChar nvarchar(1);
		  SET @TempChar = SUBSTRING(@InputData,@Counter,1)

		  IF @TempChar = '0' OR @TempChar = '1' OR @TempChar = '2' OR @TempChar = '3' OR @TempChar = '4' OR @TempChar = '5' OR @TempChar = '6' OR @TempChar = '7' OR @TempChar = '8' OR @TempChar = '9' OR @TempChar = 'A' COLLATE Latin1_General_CS_AS OR @TempChar = 'B' COLLATE Latin1_General_CS_AS OR @TempChar = 'C' COLLATE Latin1_General_CS_AS OR @TempChar = 'D' COLLATE Latin1_General_CS_AS OR @TempChar = 'E' COLLATE Latin1_General_CS_AS OR @TempChar = 'F' COLLATE Latin1_General_CS_AS OR @TempChar = 'G' COLLATE Latin1_General_CS_AS OR @TempChar = 'H' COLLATE Latin1_General_CS_AS OR @TempChar = 'I' COLLATE Latin1_General_CS_AS OR @TempChar = 'J' COLLATE Latin1_General_CS_AS OR @TempChar = 'K' COLLATE Latin1_General_CS_AS OR @TempChar = 'L' COLLATE Latin1_General_CS_AS OR @TempChar = 'M' COLLATE Latin1_General_CS_AS OR @TempChar = 'N' COLLATE Latin1_General_CS_AS OR @TempChar = 'O' COLLATE Latin1_General_CS_AS OR @TempChar = 'P' COLLATE Latin1_General_CS_AS OR @TempChar = 'Q' COLLATE Latin1_General_CS_AS OR @TempChar = 'R' COLLATE Latin1_General_CS_AS OR @TempChar = 'S' COLLATE Latin1_General_CS_AS OR @TempChar = 'T' COLLATE Latin1_General_CS_AS OR @TempChar = 'U' COLLATE Latin1_General_CS_AS OR @TempChar = 'V' COLLATE Latin1_General_CS_AS OR @TempChar = 'W' COLLATE Latin1_General_CS_AS OR @TempChar = 'X' COLLATE Latin1_General_CS_AS OR @TempChar = 'Y' COLLATE Latin1_General_CS_AS OR @TempChar = 'Z' COLLATE Latin1_General_CS_AS OR @TempChar = '-' COLLATE Latin1_General_CS_AS OR @TempChar = '.' COLLATE Latin1_General_CS_AS OR @TempChar = ' ' OR @TempChar = '$' OR @TempChar = '/' OR @TempChar = '+' OR @TempChar = '%'		  
		  BEGIN
			  SET @FilteredData = @FilteredData + @TempChar;	
		  END

		  SET @Counter = @Counter + 1;	
	  END
	  SET @FilteredLength = LEN(@FilteredData);
	  IF @CheckDigit = 1
	  BEGIN
	     IF @FilteredLength > 254
			SET @FilteredData = SUBSTRING(@FilteredData,1,254);      

				        SET @FilteredLength = LEN(@FilteredData);	

		  IF @FilteredLength IS NULL
			RETURN '**';

		  SET @Counter = 1;
		  WHILE @Counter <= @FilteredLength
		  BEGIN
	  				SET @TempChar = SUBSTRING(@FilteredData,@Counter,1)
			  		IF @TempChar = '0' 
						SET @OneValue=0;
					ELSE IF @TempChar = '1' 
						SET @OneValue=1;
					ELSE IF @TempChar = '2' 
						SET @OneValue=2;
					ELSE IF @TempChar = '3' 
						SET @OneValue=3;
					ELSE IF @TempChar = '4' 
						SET @OneValue=4;
					ELSE IF @TempChar = '5' 
						SET @OneValue=5;
					ELSE IF @TempChar = '6' 
						SET @OneValue=6;
					ELSE IF @TempChar = '7' 
						SET @OneValue=7;
					ELSE IF @TempChar = '8' 
						SET @OneValue=8;
					ELSE IF @TempChar = '9' 
						SET @OneValue=9;
					ELSE IF @TempChar = 'A' 
						SET @OneValue=10;
					ELSE IF @TempChar = 'B' 
						SET @OneValue=11;
					ELSE IF @TempChar = 'C' 
						SET @OneValue=12;
					ELSE IF @TempChar = 'D' 
						SET @OneValue=13;
					ELSE IF @TempChar = 'E' 
						SET @OneValue=14;
					ELSE IF @TempChar = 'F' 
						SET @OneValue=15;
					ELSE IF @TempChar = 'G' 
						SET @OneValue=16;
					ELSE IF @TempChar = 'H' 
						SET @OneValue=17;
					ELSE IF @TempChar = 'I' 
						SET @OneValue=18;
					ELSE IF @TempChar = 'J' 
						SET @OneValue=19;
					ELSE IF @TempChar = 'K' 
						SET @OneValue=20;
					ELSE IF @TempChar = 'L' 
						SET @OneValue=21;
					ELSE IF @TempChar = 'M' 
						SET @OneValue=22;
					ELSE IF @TempChar = 'N' 
						SET @OneValue=23;
					ELSE IF @TempChar = 'O' 
						SET @OneValue=24;
					ELSE IF @TempChar = 'P' 
						SET @OneValue=25;
					ELSE IF @TempChar = 'Q' 
						SET @OneValue=26;
					ELSE IF @TempChar = 'R' 
						SET @OneValue=27;
					ELSE IF @TempChar = 'S' 
						SET @OneValue=28;
					ELSE IF @TempChar = 'T' 
						SET @OneValue=29;
					ELSE IF @TempChar = 'U' 
						SET @OneValue=30;
					ELSE IF @TempChar = 'V' 
						SET @OneValue=31;
					ELSE IF @TempChar = 'W' 
						SET @OneValue=32;
					ELSE IF @TempChar = 'X' 
						SET @OneValue=33;
					ELSE IF @TempChar = 'Y' 
						SET @OneValue=34;
					ELSE IF @TempChar = 'Z' 
						SET @OneValue=35;
					ELSE IF @TempChar = '-' 
						SET @OneValue=36;
					ELSE IF @TempChar = '.' 
						SET @OneValue=37;
					ELSE IF @TempChar = ' ' 
						SET @OneValue=38;
					ELSE IF @TempChar = '$' 
						SET @OneValue=39;
					ELSE IF @TempChar = '/' 
						SET @OneValue=40;
					ELSE IF @TempChar = '+' 
						SET @OneValue=41;
					ELSE IF @TempChar = '%'  
						SET @OneValue=42;
			  SET @Counter = @Counter + 1;	
			  SET @SumValue = @SumValue + @OneValue;						

		  END
		  SET @SumValue = @SumValue % 43;

			IF @SumValue = 0 
				SET @CD='0';
			ELSE IF @SumValue = 1 
				SET @CD='1';
			ELSE IF @SumValue = 2 
				SET @CD='2';
			ELSE IF @SumValue = 3 
				SET @CD='3';
			ELSE IF @SumValue = 4 
				SET @CD='4';
			ELSE IF @SumValue = 5 
				SET @CD='5';
			ELSE IF @SumValue = 6 
				SET @CD='6';
			ELSE IF @SumValue = 7 
				SET @CD='7';
			ELSE IF @SumValue = 8 
				SET @CD='8';
			ELSE IF @SumValue = 9 
				SET @CD='9';
			ELSE IF @SumValue = 10 
				SET @CD='A';
			ELSE IF @SumValue = 11 
				SET @CD='B';
			ELSE IF @SumValue = 12 
				SET @CD='C';
			ELSE IF @SumValue = 13 
				SET @CD='D';
			ELSE IF @SumValue = 14 
				SET @CD='E';
			ELSE IF @SumValue = 15 
				SET @CD='F';
			ELSE IF @SumValue = 16 
				SET @CD='G';
			ELSE IF @SumValue = 17 
				SET @CD='H';
			ELSE IF @SumValue = 18 
				SET @CD='I';
			ELSE IF @SumValue = 19 
				SET @CD='J';
			ELSE IF @SumValue = 20 
				SET @CD='K';
			ELSE IF @SumValue = 21 
				SET @CD='L';
			ELSE IF @SumValue = 22 
				SET @CD='M';
			ELSE IF @SumValue = 23 
				SET @CD='N';
			ELSE IF @SumValue = 24 
				SET @CD='O';
			ELSE IF @SumValue = 25 
				SET @CD='P';
			ELSE IF @SumValue = 26 
				SET @CD='Q';
			ELSE IF @SumValue = 27 
				SET @CD='R';
			ELSE IF @SumValue = 28 
				SET @CD='S';
			ELSE IF @SumValue = 29 
				SET @CD='T';
			ELSE IF @SumValue = 30 
				SET @CD='U';
			ELSE IF @SumValue = 31 
				SET @CD='V';
			ELSE IF @SumValue = 32 
				SET @CD='W';
			ELSE IF @SumValue = 33 
				SET @CD='X';
			ELSE IF @SumValue = 34 
				SET @CD='Y';
			ELSE IF @SumValue = 35 
				SET @CD='Z';
			ELSE IF @SumValue = 36 
				SET @CD='-';
			ELSE IF @SumValue = 37 
				SET @CD='.';
			ELSE IF @SumValue = 38 
				SET @CD=' ';
			ELSE IF @SumValue = 39 
				SET @CD='$';
			ELSE IF @SumValue = 40 
				SET @CD='/';
			ELSE IF @SumValue = 41 
				SET @CD='+';
			ELSE IF @SumValue = 42 
				SET @CD='%';

	  END
	  ELSE
	  BEGIN
		IF @FilteredLength > 255 
			SET @FilteredData = SUBSTRING(@FilteredData,1,255);
	  END

      SET @Result = '*' + @FilteredData + @CD + '*'; 
      RETURN(@Result);
  END
GO