-- Copyright 2006-2020 ConnectCode Pte Ltd. All Rights Reserved.
-- This source code is protected by Copyright Laws. You are only allowed to modify
-- and include the source in your application if you have purchased a Distribution License.
-- ===================================================================================
-- ConnectCode Barcode TSQL UDF for SQL Server
--
-- The formulas in this file can be used for creating barcodes in Microsoft SQL SErver.

CREATE OR ALTER FUNCTION dbo.getEXT5PARITYMAP(@Digit1 int, @Digit2 int)
  RETURNS int
  AS
  BEGIN

	IF @Digit1=0 AND @Digit2=0 
		RETURN 1;
	ELSE IF @Digit1=0 AND @Digit2=1 
		RETURN 1;
	ELSE IF @Digit1=0 AND @Digit2=2 
		RETURN 0;
	ELSE IF @Digit1=0 AND @Digit2=3 
		RETURN 0;
	ELSE IF @Digit1=0 AND @Digit2=4 
		RETURN 0;

	IF @Digit1=1 AND @Digit2=0 
		RETURN 1;
	ELSE IF @Digit1=1 AND @Digit2=1 
		RETURN 0;
	ELSE IF @Digit1=1 AND @Digit2=2 
		RETURN 1;
	ELSE IF @Digit1=1 AND @Digit2=3 
		RETURN 0;
	ELSE IF @Digit1=1 AND @Digit2=4 
		RETURN 0;

	IF @Digit1=2 AND @Digit2=0 
		RETURN 1;
	ELSE IF @Digit1=2 AND @Digit2=1 
		RETURN 0;
	ELSE IF @Digit1=2 AND @Digit2=2 
		RETURN 0;
	ELSE IF @Digit1=2 AND @Digit2=3 
		RETURN 1;
	ELSE IF @Digit1=2 AND @Digit2=4 
		RETURN 0;

	IF @Digit1=3 AND @Digit2=0 
		RETURN 1;
	ELSE IF @Digit1=3 AND @Digit2=1 
		RETURN 0;
	ELSE IF @Digit1=3 AND @Digit2=2 
		RETURN 0;
	ELSE IF @Digit1=3 AND @Digit2=3 
		RETURN 0;
	ELSE IF @Digit1=3 AND @Digit2=4 
		RETURN 1;

	IF @Digit1=4 AND @Digit2=0 
		RETURN 0;
	ELSE IF @Digit1=4 AND @Digit2=1 
		RETURN 1;
	ELSE IF @Digit1=4 AND @Digit2=2 
		RETURN 1;
	ELSE IF @Digit1=4 AND @Digit2=3 
		RETURN 0;
	ELSE IF @Digit1=4 AND @Digit2=4 
		RETURN 0;

	IF @Digit1=5 AND @Digit2=0 
		RETURN 0;
	ELSE IF @Digit1=5 AND @Digit2=1 
		RETURN 0;
	ELSE IF @Digit1=5 AND @Digit2=2 
		RETURN 1;
	ELSE IF @Digit1=5 AND @Digit2=3 
		RETURN 1;
	ELSE IF @Digit1=5 AND @Digit2=4 
		RETURN 0;

	IF @Digit1=6 AND @Digit2=0 
		RETURN 0;
	ELSE IF @Digit1=6 AND @Digit2=1 
		RETURN 0;
	ELSE IF @Digit1=6 AND @Digit2=2 
		RETURN 0;
	ELSE IF @Digit1=6 AND @Digit2=3 
		RETURN 1;
	ELSE IF @Digit1=6 AND @Digit2=4 
		RETURN 1;

	IF @Digit1=7 AND @Digit2=0 
		RETURN 0;
	ELSE IF @Digit1=7 AND @Digit2=1 
		RETURN 1;
	ELSE IF @Digit1=7 AND @Digit2=2 
		RETURN 0;
	ELSE IF @Digit1=7 AND @Digit2=3 
		RETURN 1;
	ELSE IF @Digit1=7 AND @Digit2=4 
		RETURN 0;

	IF @Digit1=8 AND @Digit2=0 
		RETURN 0;
	ELSE IF @Digit1=8 AND @Digit2=1 
		RETURN 1;
	ELSE IF @Digit1=8 AND @Digit2=2 
		RETURN 0;
	ELSE IF @Digit1=8 AND @Digit2=3 
		RETURN 0;
	ELSE IF @Digit1=8 AND @Digit2=4 
		RETURN 1;

	IF @Digit1=9 AND @Digit2=0 
		RETURN 0;
	ELSE IF @Digit1=9 AND @Digit2=1 
		RETURN 0;
	ELSE IF @Digit1=9 AND @Digit2=2 
		RETURN 1;
	ELSE IF @Digit1=9 AND @Digit2=3 
		RETURN 0;
	ELSE IF @Digit1=9 AND @Digit2=4 
		RETURN 1;

	RETURN 0;

  END
Go

CREATE OR ALTER FUNCTION dbo.EncodeEXT5( @InputData nvarchar(255))
  RETURNS nvarchar(255)
  AS
  BEGIN    
	  DECLARE @TempChar nvarchar(1);
	  DECLARE @Barcodechar nvarchar(1);
	  DECLARE @Barcodevalue int=0;
	  DECLARE @SumValue int=0;
	  DECLARE @OneValue int=0;
	  DECLARE @Chk int=0;
	  DECLARE @Lendiff int=0;
	  DECLARE @Modvalue1 int=0;
      DECLARE @FilteredData nvarchar(255)='';
      DECLARE @ResultData nvarchar(255)=''; 
	  DECLARE @FilteredLength int=LEN(@InputData);	  
   	  DECLARE @Parityindex    int=0;
   	  DECLARE @Paritybit    int=0;
   	  DECLARE @Datalength   int=0;
   	  DECLARE @Transformdata nvarchar(255)='';

	  DECLARE @Counter int;
	  DECLARE @X int;

	  IF @FilteredLength IS NULL 
	  BEGIN
		  RETURN('');
	  END

	  IF @FilteredLength <= 0 
	  BEGIN
		  RETURN('');
	  END

      SET @Counter = 1;
	  While @Counter<=@FilteredLength
	  BEGIN
			SET @TempChar = SUBSTRING(@InputData,@Counter,1);
			SET @OneValue = ASCII(@TempChar);
			IF @OneValue >= 48 AND @OneValue <=57 
				SET @FilteredData = @FilteredData + @TempChar;
	        SET @Counter = @Counter+1;
	  END
	  SET @FilteredLength = LEN(@FilteredData);	
	  IF @FilteredLength IS NULL 
	  BEGIN
		  RETURN('');
	  END

	  IF @FilteredLength <= 0 
	  BEGIN
		  RETURN('');
	  END
	  
	   SET @FilteredLength = LEN(@FilteredData);	
	   IF @FilteredLength > 5 
		SET @FilteredData = SUBSTRING(@FilteredData,1,5);

	   SET @FilteredLength = LEN(@FilteredData);	
	   IF @FilteredLength < 5
	   BEGIN
		SET @Lendiff=5-@FilteredLength;
		SET @Counter = 1;
		While @Counter<=@Lendiff
		BEGIN
			SET @FilteredData = '0' + @FilteredData;	
			SET @Counter = @Counter+1;
		END
	   END

	   SET @Sumvalue=0;
       SET @Datalength=LEN(@FilteredData);

		SET @X = 1;
		While @X<=@Datalength
		BEGIN
			  SET @Barcodechar=SUBSTRING(@FilteredData,@X,1);
			  SET @Barcodevalue=ASCII(@Barcodechar);	
			  SET @Modvalue1 = @X % 2;

			  IF @Modvalue1=1 
  				SET @Sumvalue = @Sumvalue + (3 * (@Barcodevalue-48));
			  ELSE
			    SET @SumValue = @SumValue + (9 * (@Barcodevalue-48));
              SET @X=@X+1;
		END
		
	    SET @Chk =@SumValue % 10;

		SET @X = 1;
		While @X<=5
		BEGIN
 		  SET @Paritybit=0;
		  SET @Paritybit=dbo.getEXT5PARITYMAP(@Chk,@X-1);
		  IF @Paritybit=0  
			SET @Transformdata=@Transformdata+SUBSTRING(@FilteredData,@X,1);
		  ELSE
			SET @Transformdata=@Transformdata+CHAR(ASCII(SUBSTRING(@FilteredData,@X,1)) + 49 + 14);				
          SET @X=@X+1;
		End

     SET @Resultdata= '<' + SUBSTRING(@Transformdata,1,1) + '+' + SUBSTRING(@Transformdata,2,1) + '+' + SUBSTRING(@Transformdata,3,1) + '+' + SUBSTRING(@Transformdata,4,1) + '+' + SUBSTRING(@Transformdata,5,1);    

	 RETURN @ResultData;

  END
GO