-- Copyright 2006-2020 ConnectCode Pte Ltd. All Rights Reserved.
-- This source code is protected by Copyright Laws. You are only allowed to modify
-- and include the source in your application if you have purchased a Distribution License.
-- ===================================================================================
-- ConnectCode Barcode TSQL UDF for SQL Server
--
-- The formulas in this file can be used for creating barcodes in Microsoft SQL SErver.

CREATE OR ALTER FUNCTION dbo.I2of5UNICHR(@DataNum  int )
  RETURNS nchar
  AS
  BEGIN
      DECLARE @ReturnString nchar;
	  SET @ReturnString='';

	  IF @DataNum>=191 and @DataNum<=199  
		   SET @ReturnString = nchar(@DataNum);
	  ELSE IF @DataNum>=227 and @DataNum<=238
		   SET @ReturnString = nchar(@DataNum);
      ELSE
		   SET @ReturnString = char(@DataNum);
    

      RETURN(@ReturnString);
  END
GO

CREATE OR ALTER FUNCTION dbo.EncodeI2of5( @InputData nvarchar(255), @CheckDigit int)
  RETURNS nvarchar(255)
  AS
  BEGIN    
	  DECLARE @TempChar nvarchar(2);
	  DECLARE @Weight int=1;
      DECLARE @Sumvalue int=0;
      DECLARE @Onevalue int=0;
      DECLARE @Chkvalue int=0;
      DECLARE @Toggle int=1;
	  DECLARE @CD nvarchar(2)='';
      DECLARE @FilteredData nvarchar(255)='';
      DECLARE @ReturnData nvarchar(560)=''; 
	  DECLARE @FilteredLength int=LEN(@InputData);
	  DECLARE @Counter int=1;
	  DECLARE @X int=1;

	  IF @FilteredLength <= 0 
	  BEGIN
	      SET @ReturnData = ''; 
		  RETURN(@ReturnData);
	  END

	  WHILE @Counter <= @FilteredLength
	  BEGIN

		SET @TempChar = SUBSTRING(@InputData,@Counter,1);
		SET @Onevalue = ASCII(@TempChar);
		IF @Onevalue >= 48 AND @Onevalue <=57  
			SET @FilteredData = @FilteredData + @TempChar;
        SET @Counter=@Counter+1;
      END
	  
      SET @FilteredLength = LEN(@FilteredData);	
      IF @FilteredLength IS NULL 
		RETURN '';
		
      if @CheckDigit=1
	  BEGIN
		  SET @FilteredLength = LEN(@FilteredData);	
		  IF @FilteredLength > 253 
			SET @FilteredData = SUBSTRING(@FilteredData,1,253);

		  SET @FilteredLength = LEN(@FilteredData);	
   	      IF @FilteredLength % 2 = 0
    		SET @Filtereddata = '0' + @Filtereddata;

		  SET @FilteredLength = LEN(@FilteredData);	
  		  SET @X = @FilteredLength;
		  WHILE @X >=1 
	      BEGIN
			SET @Tempchar=SUBSTRING(@FilteredData,@X,1);
			SET @Onevalue=ASCII(@TempChar) - 48;
			IF @Toggle = 1
			BEGIN
				SET @Sumvalue = @Sumvalue + (@Onevalue*3);
				SET @Toggle = 0;
			END
			ELSE
			BEGIN
				SET @Sumvalue = @Sumvalue + @Onevalue;
				SET @Toggle = 1;
			END	

			SET @X=@X-1
          END

		  IF @Sumvalue % 10 = 0
			SET @Chkvalue = 0 + 48;
  		  ELSE
			SET @Chkvalue = (10 - (@Sumvalue%10)) + 48;
	 	  SET @cd=dbo.I2of5UNICHR(@Chkvalue);
	  END
	  ELSE
	  BEGIN
	  	SET @Filteredlength = LEN(@FilteredData);	
	   	IF @Filteredlength > 254
    		SET @FilteredData = SUBSTRING(@FilteredData,1,254);

	  	SET @Filteredlength = LEN(@FilteredData);	
   		IF @FilteredLength%2 = 1
    			SET @FilteredData = '0' + @Filtereddata;
	  END
	  
	  SET @FilteredData = @FilteredData + @CD;	
	  SET @FilteredLength = LEN(@FilteredData);	
	  
	  SET @Counter = 1;
	  WHILE @Counter <=@FilteredLength 
	  BEGIN
		IF @Counter%2 = 1
		BEGIN
		  SET @Tempchar = SUBSTRING(@FilteredData,@Counter,2);
		  SET @Onevalue = CAST(@TempChar as int);

		  IF @Onevalue <= 90 AND @Onevalue >= 0 
			SET @Returndata = @Returndata + dbo.I2of5UNICHR(@Onevalue+32);
		  ELSE IF @Onevalue <= 99 AND @Onevalue >= 91 
			SET @Returndata = @Returndata + dbo.I2of5UNICHR(@Onevalue+100);
		  ELSE
			SET @Returndata = @Returndata;      
		END
		SET @Counter=@Counter+1;
	  END

      SET @ReturnData = '{' + @ReturnData + '}';
		   
    RETURN(@ReturnData);
  END
GO